//
//  RWDCreateDealViewController.m
//  ReactiveWebDB
//
//  Created by Kenichi Yonekawa on 6/16/14.
//  Copyright (c) 2014 freee K.K. All rights reserved.
//

#import "RWDCreateDealViewController.h"
#import "RWDCreateDealViewModel.h"

@interface RWDCreateDealViewController ()
@property (nonatomic, strong) RWDCreateDealViewModel *viewModel;

@property (nonatomic, weak) IBOutlet UITextField *issueDateField;
@property (nonatomic, weak) IBOutlet UITextField *amountField;
@property (nonatomic, weak) IBOutlet UITextField *memoField;
@property (nonatomic, weak) IBOutlet UIBarButtonItem *saveButton;
@end

@implementation RWDCreateDealViewController

- (void)viewDidLoad
{
    [super viewDidLoad];

    self.viewModel = [RWDCreateDealViewModel new];

    [self.issueDateField.rac_textSignal subscribeNext:^(NSString *issueDate) {
        self.viewModel.deal.issueDate = [NSDate date];
    }];
    [self.amountField.rac_textSignal subscribeNext:^(NSString *amount) {
        self.viewModel.deal.amount = [amount longLongValue];
    }];
    
    [[RACSignal
      combineLatest:@[
        self.issueDateField.rac_textSignal,
        self.amountField.rac_textSignal
      ]
      reduce:^id(NSString *issueDate, NSString *amount) {
          return @([issueDate length] > 9 && [amount integerValue] > 0);
      }]
      subscribeNext:^(id value) {
          self.saveButton.enabled = [value boolValue];
      }];
}

@end
