//
//  RWDCreateDealViewModel.m
//  ReactiveWebDB
//
//  Created by Kenichi Yonekawa on 6/21/14.
//  Copyright (c) 2014 freee K.K. All rights reserved.
//

#import "RWDCreateDealViewModel.h"

@interface RWDCreateDealViewModel()
@property (nonatomic, strong, readwrite) RWDDeal *deal;
@end

@implementation RWDCreateDealViewModel

- (id)init
{
    self = [super init];
    if (self) {
        self.deal = [RWDDeal new];
    }
    return self;
}

- (RACSignal *)validateDeal
{
    return [RACSignal combineLatest:@[
        RACObserve(self.deal, issueDate),
        RACObserve(self.deal, amount)
    ] reduce:^id (NSString *issueDate, NSString *amount) {
        return @([issueDate length] > 0 && [amount longLongValue] > 0);
    }];
}

- (RACSignal *)saveDeal
{
    return [RACSignal createSignal:^RACDisposable *(id<RACSubscriber> subscriber) {
        [self.deal save];
        return nil;
    }];
}

@end
